# coding: utf-8

"""
    perceptic-core-server API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1-SNAPSHOT
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from perceptic_core_client.models.cron_trigger import CronTrigger
from perceptic_core_client.models.interval_trigger import IntervalTrigger
from perceptic_core_client.models.on_upload_trigger import OnUploadTrigger
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SCHEDULETRIGGER_ONE_OF_SCHEMAS = ["CronTrigger", "IntervalTrigger", "OnUploadTrigger"]

class ScheduleTrigger(BaseModel):
    """
    ScheduleTrigger
    """
    # data type: OnUploadTrigger
    oneof_schema_1_validator: Optional[OnUploadTrigger] = None
    # data type: CronTrigger
    oneof_schema_2_validator: Optional[CronTrigger] = None
    # data type: IntervalTrigger
    oneof_schema_3_validator: Optional[IntervalTrigger] = None
    actual_instance: Optional[Union[CronTrigger, IntervalTrigger, OnUploadTrigger]] = None
    one_of_schemas: Set[str] = { "CronTrigger", "IntervalTrigger", "OnUploadTrigger" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ScheduleTrigger.model_construct()
        error_messages = []
        match = 0
        # validate data type: OnUploadTrigger
        if not isinstance(v, OnUploadTrigger):
            error_messages.append(f"Error! Input type `{type(v)}` is not `OnUploadTrigger`")
        else:
            match += 1
        # validate data type: CronTrigger
        if not isinstance(v, CronTrigger):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CronTrigger`")
        else:
            match += 1
        # validate data type: IntervalTrigger
        if not isinstance(v, IntervalTrigger):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IntervalTrigger`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ScheduleTrigger with oneOf schemas: CronTrigger, IntervalTrigger, OnUploadTrigger. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ScheduleTrigger with oneOf schemas: CronTrigger, IntervalTrigger, OnUploadTrigger. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `CronTrigger`
        if _data_type == "cron":
            instance.actual_instance = CronTrigger.from_json(json_str)
            return instance

        # check if data type is `IntervalTrigger`
        if _data_type == "interval":
            instance.actual_instance = IntervalTrigger.from_json(json_str)
            return instance

        # check if data type is `OnUploadTrigger`
        if _data_type == "onUpload":
            instance.actual_instance = OnUploadTrigger.from_json(json_str)
            return instance

        # check if data type is `CronTrigger`
        if _data_type == "CronTrigger":
            instance.actual_instance = CronTrigger.from_json(json_str)
            return instance

        # check if data type is `IntervalTrigger`
        if _data_type == "IntervalTrigger":
            instance.actual_instance = IntervalTrigger.from_json(json_str)
            return instance

        # check if data type is `OnUploadTrigger`
        if _data_type == "OnUploadTrigger":
            instance.actual_instance = OnUploadTrigger.from_json(json_str)
            return instance

        # deserialize data into OnUploadTrigger
        try:
            instance.actual_instance = OnUploadTrigger.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into CronTrigger
        try:
            instance.actual_instance = CronTrigger.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into IntervalTrigger
        try:
            instance.actual_instance = IntervalTrigger.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ScheduleTrigger with oneOf schemas: CronTrigger, IntervalTrigger, OnUploadTrigger. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ScheduleTrigger with oneOf schemas: CronTrigger, IntervalTrigger, OnUploadTrigger. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], CronTrigger, IntervalTrigger, OnUploadTrigger]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


