# coding: utf-8

"""
    perceptic-core-server API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1-SNAPSHOT
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from perceptic_core_client.models.schedule_trigger import ScheduleTrigger
from typing import Optional, Set
from typing_extensions import Self

class UpdateIndexingScheduleRequest(BaseModel):
    """
    UpdateIndexingScheduleRequest
    """ # noqa: E501
    name: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Updated display name")
    description: Optional[Annotated[str, Field(strict=True, max_length=1000)]] = Field(default=None, description="Updated description")
    target_minimum_version: Optional[StrictInt] = Field(default=None, description="Updated minimum indexer version", alias="targetMinimumVersion")
    indexing_settings: Optional[Dict[str, Any]] = Field(default=None, description="Updated indexer-specific settings", alias="indexingSettings")
    trigger: Optional[ScheduleTrigger] = None
    enabled: Optional[StrictBool] = Field(default=None, description="Updated enabled status")
    __properties: ClassVar[List[str]] = ["name", "description", "targetMinimumVersion", "indexingSettings", "trigger", "enabled"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateIndexingScheduleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of trigger
        if self.trigger:
            _dict['trigger'] = self.trigger.to_dict()
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if target_minimum_version (nullable) is None
        # and model_fields_set contains the field
        if self.target_minimum_version is None and "target_minimum_version" in self.model_fields_set:
            _dict['targetMinimumVersion'] = None

        # set to None if trigger (nullable) is None
        # and model_fields_set contains the field
        if self.trigger is None and "trigger" in self.model_fields_set:
            _dict['trigger'] = None

        # set to None if enabled (nullable) is None
        # and model_fields_set contains the field
        if self.enabled is None and "enabled" in self.model_fields_set:
            _dict['enabled'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateIndexingScheduleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "targetMinimumVersion": obj.get("targetMinimumVersion"),
            "indexingSettings": obj.get("indexingSettings"),
            "trigger": ScheduleTrigger.from_dict(obj["trigger"]) if obj.get("trigger") is not None else None,
            "enabled": obj.get("enabled")
        })
        return _obj


